<!-- <app-parent></app-parent> -->
<link rel='stylesheet' href='app.component.css'>

<!-- class binding -->
<p  class='background' [class]='appliedclasses'>HELLO!!!!</p>

<p class ='font background  color' [class.background]='appliedbackground'>WELCOME</p>

<p class ='font background  color' [ngClass]='multiclass()'>GOOD EVENING</p>

<!-- attribute binding -->
<table border="1px solid black" >
    <thead >
    <tr>
        <th [attr.colSpan]='columnspan'>Details</th>
    </tr>
    </thead>
    <tbody>
    <tr>
        <td>firstname</td>
        <td>{{firstname}}</td>
        <td>{{secondname}}</td>
    </tr>
    <tr>
        <td>lastname</td>
        <td>{{lastname}}</td>
        <td>{{lastname}}</td>
    </tr>
    <tbody>
</table>

<!-- style binding-->
<p [style.text-decoration]="decorationstyle">Be Safe</p>
<p [ngStyle]='decorationstyle()'>GOOD EVENING</p> 

<!-- date pipe  -->
<p>{{date | date}}</p>
<p>{{ birthday | date }}</p>
<p>{{ birthday | date:"MM/dd/yy" }} </p>
<p>{{ birthday | date | uppercase}}</p>
<p>{{ birthday | date:"short" | in: 'female'}}</p>
<p>{{ birthday | date:'fullDate' | uppercase}}</p>

<!-- two-way binding -->
<h2>Two-way Binding Example</h2>    
<input [(ngModel)]="fname">
<p> {{fname}} </p> 

<input [value]="lname" (input)='lname=$event.target.value'> 
<p>{{lname}}</p>

<button (click)="show()">show</button>

<!-- directives >-->
<div *ngIf="array.length > 0 ;  then arrayfull else arrayempty" ></div>
 ( 1)  <div *ngIf="array.length == 0">array is empty</div>
<ng-template #arrayfull>
    <br>array have elements
</ng-template>
<ng-template #arrayempty>
    array is empty
</ng-template>

<!-- custom directives-->
<p appCustom>custom directive</p>
<p *appCustomstructural="active">structural directive</p>

<button type="submit" (click)="display()">clickme</button>
<p *appDynamicdir></p> 

<!-- service injector  -->
<app-ser-inj></app-ser-inj>
<app-ser-inj2></app-ser-inj2>

<!-- observable -->
<app-observable></app-observable> 
<app-async-pipe></app-async-pipe>

<!-- forms -->
<app-reactive></app-reactive>
<app-template></app-template> 
<app-react-form></app-react-form>